Author: Ubuntu Touch Developers
Description: Avoid crash while parsing vCards from different threads.
Forwarded: https://lists.qt-project.org/pipermail/development/2020-March/039208.html

=== modified file 'src/versit/qversitreader_p.cpp'
--- a/src/versit/qversitreader_p.cpp
+++ b/src/versit/qversitreader_p.cpp
@@ -43,6 +43,7 @@
 #include <QtCore/qbuffer.h>
 #include <QtCore/qtextcodec.h>
 #include <QtCore/qvariant.h>
+#include <QtCore/QReadWriteLock>
 
 #include "qversitutils_p.h"
 
@@ -428,7 +429,18 @@
 
 QHash<QPair<QVersitDocument::VersitType,QString>, QVersitProperty::ValueType>*
 QVersitReaderPrivate::valueTypeMap() {
+    static QReadWriteLock valueTypeMapLock;
+
+    QReadLocker readLock(&valueTypeMapLock);
     if (mValueTypeMap == 0) {
+        readLock.unlock();
+
+        QWriteLocker writeLock(&valueTypeMapLock);
+        // check if map still empty
+        if (mValueTypeMap) {
+            return mValueTypeMap;
+        }
+
         mValueTypeMap = new QHash<QPair<QVersitDocument::VersitType,QString>, QVersitProperty::ValueType>();
         mValueTypeMap->insert(qMakePair(QVersitDocument::VCard21Type, QString::fromLatin1("AGENT")),
                              QVersitProperty::VersitDocumentType);
